/*********
  Rui Santos
  Complete project details at https://randomnerdtutorials.com/esp8266-dht11dht22-temperature-and-humidity-web-server-with-arduino-ide/
  https://randomnerdtutorials.com/how-to-install-esp8266-board-arduino-ide/

  # https://os.mbed.com/users/ms523/notebook/turning-an-mbed-circuit-into-a-custom-pcb/
# https://www.electrodragon.com/w/RDA5981
# https://arduinodiy.wordpress.com/2016/10/11/using-the-4-pins-of-the-esp8266-01/
# https://homecircuits.eu/blog/battery-powered-esp8266-iot-logger/
*********/

// Import required libraries
#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <Hash.h>
#include <ESPAsyncTCP.h>
#include <ESPAsyncWebServer.h>
#include <Adafruit_Sensor.h>
#include <DHT.h>
#include <EEPROM.h>
#include "version_num.h"
#include "build_defs.h"


// Replace with your network credentials
const char* ssid = "007";
const char* password = "0958070380";

const char* ssid_soft     = "ESP8266-210-AP";
const char* password_soft = "123456789";


#define LOCAL_IP_ADDRESS 210

IPAddress local_IP(192,168,4,LOCAL_IP_ADDRESS);
IPAddress gateway(192,168,4,10);
IPAddress subnet(255,255,255,0);

#define DHTPIN 2     // Digital pin connected to the DHT sensor

// Uncomment the type of sensor in use:
#define DHTTYPE    DHT11     // DHT 11
//#define DHTTYPE    DHT22     // DHT 22 (AM2302)
//#define DHTTYPE    DHT21     // DHT 21 (AM2301)

DHT dht(DHTPIN, DHTTYPE);

// current temperature & humidity, updated in loop()
float t = 0.0;
float h = 0.0;

// Create AsyncWebServer object on port 80

// https://question-it.com/questions/149459/esp32-asyncwebserver

#define favicon_ico_gz_len 4308
const uint8_t favicon_ico_gz[] PROGMEM = {
0x1f,0x8b,0x08,0x08,0xc2,0x24,0x37,0x61,0x04,0x00,0x66,0x61,0x76,0x69,0x63,0x6f ,
0x6e,0x2e,0x69,0x63,0x6f,0x00,0xed,0x59,0xf7,0x6f,0x1b,0x55,0x1c,0x77,0xd3,0x26 ,
0xa5,0x40,0x4b,0x81,0x02,0x65,0xb4,0xb1,0xef,0xce,0x49,0x70,0x07,0x23,0x02,0xc4 ,
0x54,0xf8,0x81,0x11,0xa0,0x2c,0x51,0x24,0x76,0x19,0x0a,0x43,0x94,0xad,0xb2,0x04 ,
0x18,0x24,0x46,0x49,0x9b,0xc4,0x3b,0x76,0xec,0x34,0xa5,0x65,0x05,0x84,0x18,0x62 ,
0x23,0x40,0x80,0x20,0x94,0x40,0x28,0x5b,0x2a,0x50,0x4a,0x43,0x96,0xf7,0x5e,0x49 ,
0xbe,0x7c,0x3f,0xef,0xee,0x25,0x6e,0x01,0xc1,0x1f,0x80,0xa5,0xa7,0xbb,0x77,0xef ,
0xbd,0xef,0x9e,0xcf,0x26,0xd3,0x0c,0xd3,0x4c,0x93,0xd9,0x8c,0xa7,0xd9,0xd4,0x30 ,
0xdf,0x64,0x3a,0xd6,0x64,0x32,0x2d,0x5c,0x68,0xcc,0xe7,0x98,0x4c,0x57,0xf2,0xb7 ,
0xf9,0xf3,0x8d,0xf9,0x2c,0x93,0xe9,0xb1,0x83,0x4d,0xa6,0x06,0xde,0x63,0xe6,0xd1 ,
0x64,0xd2,0xbf,0xff,0xd3,0x8f,0x88,0x66,0x18,0xaf,0x33,0xfc,0x7e,0x7f,0xf5,0x07 ,
0x1f,0x7c,0x30,0x0b,0x93,0xde,0xde,0xde,0x99,0x98,0xdb,0xed,0xf6,0x2a,0xb9,0x37 ,
0x1a,0xb0,0x2d,0x29,0x07,0x95,0x7b,0xb3,0x9d,0xca,0xdb,0xe9,0x4e,0xf5,0x97,0xb4 ,
0x5b,0x89,0xa6,0xdd,0x96,0x68,0xba,0xd3,0xf2,0x4b,0x36,0x60,0x7d,0xa7,0xdc,0x65 ,
0xb9,0x2f,0xcd,0x7b,0x2a,0xe1,0x03,0x9e,0x84,0x09,0x58,0x80,0xc9,0x38,0xab,0x24 ,
0x6e,0x03,0x57,0x4d,0x5b,0x5b,0xdb,0x1c,0xcc,0x81,0xf7,0xa6,0x9b,0x6e,0xda,0xbb ,
0xa5,0xa5,0xa5,0x5a,0xc2,0xd8,0xd6,0x76,0xc4,0x92,0x7c,0x97,0xf9,0x99,0x5c,0xc0 ,
0x52,0xa6,0x8d,0x0d,0x44,0x1b,0xac,0x34,0x11,0x54,0x28,0xe7,0xd7,0x28,0xd3,0x69 ,
0xa5,0xf1,0xa0,0x4a,0xd4,0xa3,0x11,0x6d,0xac,0xa7,0x6c,0xa7,0x3a,0x5e,0xe2,0xbd ,
0x3b,0x9c,0x36,0x9b,0xc1,0xe1,0x0c,0xe0,0xbd,0xeb,0xae,0xbb,0xf6,0xe2,0x67,0x0d ,
0xbe,0xe0,0xb9,0x61,0xc3,0x86,0x3d,0x80,0x0f,0xc3,0xe9,0x74,0xce,0x66,0x7c,0x7b ,
0x62,0x5f,0x63,0x63,0x63,0xf5,0xca,0x95,0x2b,0xf7,0x6e,0x6c,0xd4,0xf1,0x8f,0x38 ,
0xb4,0xeb,0xd2,0x3e,0x2d,0x4b,0x4f,0x31,0x2e,0x9f,0x42,0x11,0x97,0x46,0x71,0xb7 ,
0x4a,0x69,0xaf,0x85,0xa2,0x6e,0x95,0x87,0x46,0x49,0x8f,0x85,0x12,0xae,0x45,0x14 ,
0x71,0xd4,0x52,0xca,0xcb,0xb4,0x6c,0xe2,0xbd,0x5e,0x25,0x33,0xe4,0xb4,0x5e,0x2f ,
0x69,0xb8,0xe2,0x8a,0x2b,0xf6,0x5a,0xb5,0x6a,0xd5,0x1e,0x90,0x33,0x9e,0xb7,0xdf ,
0x7e,0xfb,0x1c,0xf0,0x2a,0x64,0x63,0xfc,0x18,0xef,0x3e,0x2b,0x56,0xac,0xd8,0x53 ,
0xce,0x7f,0x59,0xd7,0xf0,0x20,0x6d,0xd4,0x68,0x9c,0x79,0x1d,0x75,0x6a,0x8c,0x5b ,
0xa5,0xac,0xcf,0x4c,0x09,0x8f,0x42,0x23,0x4e,0x2b,0xe3,0x52,0x28,0xe3,0x59,0x44 ,
0x63,0xeb,0x0e,0xa4,0x88,0x6f,0x29,0xe5,0x82,0x36,0x4a,0xb4,0x2f,0xa0,0xe1,0x76 ,
0x33,0x15,0xbb,0x98,0x8e,0xa7,0x54,0xda,0xd1,0x56,0xf7,0x70,0x05,0xfc,0x99,0x97 ,
0x5e,0x7a,0xe9,0xbe,0x4d,0x4d,0x4d,0xb3,0xa4,0x6e,0x40,0x03,0xf3,0x3d,0x8b,0xd7 ,
0x6a,0x40,0x57,0x53,0x93,0xa0,0xd1,0xf4,0x47,0xbb,0x76,0x0d,0xf5,0x58,0x29,0xed ,
0x53,0x05,0xbe,0x98,0xab,0x96,0x62,0x4e,0x33,0x25,0xf1,0xee,0x56,0xc5,0x88,0x3b ,
0x17,0xf3,0x9a,0x85,0x52,0x5f,0x86,0x28,0x1b,0x1f,0xa1,0x7c,0x72,0x84,0x52,0xfd ,
0x01,0x96,0x0f,0xef,0xe1,0x35,0xc8,0x0b,0x30,0x86,0xda,0xac,0x2d,0x80,0xd9,0xdc ,
0xbc,0x7a,0x36,0x70,0x34,0x37,0x37,0xcf,0x06,0x5e,0x0c,0x7c,0x87,0x2c,0xae,0xb9 ,
0xe6,0x9a,0xb9,0x92,0xce,0x77,0x1f,0x69,0x5c,0xc6,0x36,0x55,0x98,0x08,0x5a,0x04 ,
0xcf,0xa3,0x0e,0x0b,0xeb,0x55,0xa3,0x34,0xf3,0x3b,0xbc,0xfe,0x30,0x8a,0x7b,0x54 ,
0xca,0xf9,0x6a,0x29,0xb2,0xfe,0x00,0x8a,0xf6,0x05,0x68,0x9c,0x95,0x58,0x9a,0x20 ,
0x8a,0xa5,0xb2,0x94,0xc7,0xfb,0xd6,0x6e,0x8a,0xf2,0xda,0x88,0x83,0x65,0xd7,0xa5 ,
0x50,0x3e,0x60,0xc9,0x7e,0x64,0x3f,0x7a,0xb9,0xc9,0xa4,0xdb,0xf2,0xea,0xd5,0xab ,
0x67,0xaf,0x59,0xb3,0x06,0xf8,0x66,0x48,0x3a,0x60,0x6f,0x92,0x77,0xe6,0xa9,0x97 ,
0x36,0xd6,0x51,0x94,0x71,0xc7,0x99,0xef,0x84,0x97,0x71,0x6f,0xef,0xa3,0xf4,0xe0 ,
0x00,0xa5,0x82,0x47,0x52,0xac,0xed,0x40,0x8a,0x3a,0xf9,0xbb,0x7f,0x29,0xf3,0x3c ,
0x46,0xd9,0x7c,0x9e,0xe2,0xcf,0xae,0xa0,0xd4,0xb3,0xcd,0x94,0x2d,0x14,0x28,0x13 ,
0x1f,0xa3,0x38,0xaf,0x25,0x5d,0x8b,0x04,0x0c,0x01,0xcb,0xad,0xbc,0x00,0xd8,0x8c ,
0x43,0xf0,0xcf,0xf2,0x16,0x72,0xaf,0xd4,0xbf,0xa9,0xd1,0x5f,0xfd,0xcd,0x13,0xcb ,
0x96,0x15,0xfc,0xb5,0x65,0x96,0xbb,0xd0,0x79,0xca,0x0d,0x39,0x5a,0x28,0xbe,0xfd ,
0x0b,0xca,0x30,0x6f,0xe5,0xc8,0x0f,0x94,0x08,0x2c,0xa7,0x91,0xb5,0xfb,0x53,0x2a ,
0xb0,0x84,0xca,0xd9,0x28,0x25,0xb3,0x79,0x8a,0x3e,0x7d,0x16,0xe5,0x5e,0x38,0x87 ,
0xf2,0xc5,0x22,0xc5,0xc7,0xfe,0xa0,0xa4,0x7f,0x09,0xdb,0xc6,0x61,0x14,0x86,0xbd ,
0x7a,0x34,0xca,0xfb,0x2d,0x13,0xc3,0x4e,0xcd,0xa6,0x69,0xce,0xd9,0x15,0xfa,0xc7 ,
0x13,0xfe,0xb1,0x07,0xec,0x13,0xdf,0x62,0x2e,0xf5,0x7e,0xea,0xa9,0x17,0x3a,0xcc ,
0x18,0x36,0x1e,0x6e,0x3f,0x8c,0xd2,0xc1,0xe5,0x94,0x1f,0xfe,0x86,0x52,0x4c,0x43 ,
0x66,0xe8,0x5b,0xca,0x04,0x97,0x51,0xe4,0xf1,0x3d,0x28,0xfe,0xb9,0x9f,0x4a,0xfc ,
0xad,0x50,0x26,0x4a,0x65,0x0b,0x94,0xc3,0xfb,0x40,0x48,0xc8,0x3f,0xcc,0xbc,0xa7 ,
0x3c,0x16,0xe1,0x1f,0x80,0x39,0xec,0xd0,0xec,0xc0,0x01,0x1b,0x60,0x9c,0xc2,0xdf ,
0x24,0xfe,0x15,0x2b,0x5a,0x84,0xdd,0x33,0xde,0x77,0xca,0xc1,0x3a,0x81,0x3f,0xed ,
0xd5,0xf5,0x1f,0x71,0xb3,0x1c,0x3a,0x16,0x50,0x32,0xb0,0x94,0x12,0xbf,0x7f,0xad ,
0xeb,0x38,0xfc,0x23,0x45,0xbd,0x36,0x0a,0xaf,0x3b,0x80,0x72,0x5f,0x05,0xa9,0x90 ,
0x1a,0xa5,0x64,0x64,0x90,0x52,0x5f,0xf8,0x75,0xba,0x9d,0xb5,0xe0,0x5d,0xe0,0x4f ,
0xb1,0xcd,0x02,0x66,0xc4,0xa9,0xbe,0x27,0xed,0x50,0xe2,0xaf,0x94,0xff,0x6d,0xab ,
0xce,0x9f,0x1f,0x76,0xa8,0xbf,0x4d,0x06,0x15,0x81,0x7f,0x04,0xf2,0x67,0x58,0x80 ,
0x37,0xe6,0xb2,0xb2,0xbd,0x1d,0xc8,0x3e,0xb6,0x94,0xb2,0x7f,0x6c,0xa5,0x04,0xd3 ,
0x90,0x1f,0xfd,0x9e,0xb2,0x5d,0x36,0x1a,0x7d,0x6c,0x8e,0xee,0x7f,0x5d,0x87,0x53 ,
0xa2,0x6d,0x01,0x8d,0x74,0xb0,0x9f,0x78,0x15,0xf6,0x55,0x0b,0x68,0xc0,0x10,0xf1 ,
0x2a,0xe9,0x36,0xef,0xb8,0xf7,0xea,0xe6,0x03,0xa4,0x1d,0xc2,0xee,0xa4,0xff,0x21 ,
0x46,0xbc,0x6e,0x3f,0x66,0x61,0xd8,0xa5,0x44,0x0b,0xfe,0x29,0x1f,0x03,0x1d,0xc2 ,
0xff,0xa2,0x98,0x23,0xd6,0xb4,0x1f,0x40,0xf1,0xce,0xa5,0x6c,0x8b,0x5b,0x85,0x1c ,
0xf2,0x23,0x3f,0x50,0xac,0x73,0x19,0x45,0xd7,0xed,0xc7,0xf0,0x17,0x63,0xbf,0x3c ,
0xb7,0x8b,0xaf,0xe6,0x19,0x66,0xc4,0xa9,0xc4,0x3e,0x60,0x1c,0xc0,0x25,0x63,0x8f ,
0xf4,0x3f,0x93,0xad,0xb7,0x86,0x42,0x0b,0xe6,0x26,0xdc,0xb5,0xe1,0x98,0xb7,0x4e ,
0xe0,0xcc,0xf9,0xcc,0xba,0xff,0x39,0x35,0xf0,0x02,0x7d,0x30,0x6f,0x6c,0x8b,0xeb ,
0xf7,0xa5,0x5c,0x68,0x09,0xa5,0x76,0x7e,0x4d,0x09,0xa1,0x8b,0x1f,0x28,0xc3,0xf6 ,
0x31,0xdc,0x7a,0x10,0xc5,0x3c,0x1a,0xce,0x31,0x4e,0x9c,0xb3,0x42,0x76,0x62,0xc4 ,
0x19,0x26,0x78,0xa3,0x57,0x16,0xcc,0x35,0x62,0xf2,0x3c,0xe8,0x7e,0x9a,0x7f,0x7b ,
0xd5,0xed,0xb7,0xaf,0x9c,0x13,0x71,0x99,0x7f,0x2e,0x75,0xa9,0xbb,0xf1,0xcf,0xef ,
0xac,0xcf,0x68,0xdb,0x01,0x94,0x64,0x9b,0x8f,0x07,0x96,0x51,0xec,0x09,0xb6,0x3d ,
0x5f,0x03,0xe5,0x86,0xbe,0xa1,0x9c,0xb0,0xc9,0xef,0x78,0x6d,0x39,0x7c,0x53,0xd0 ,
0x10,0xf7,0xe0,0xdc,0x34,0xff,0x80,0x19,0x76,0x2b,0xbf,0xb6,0xb4,0x20,0xbe,0xda ,
0x45,0xdc,0x9b,0x92,0xc1,0xd4,0x8f,0xaa,0xc6,0x9c,0xca,0xdb,0xb4,0x51,0xea,0xdf ,
0x0a,0xfd,0xeb,0x31,0xd6,0xc9,0x71,0x70,0x0b,0xc7,0x9a,0xec,0x18,0xe5,0x92,0xa3 ,
0x14,0xe9,0x0b,0xb0,0x2e,0xf6,0xa7,0x6c,0xa0,0x41,0xd8,0x64,0x5a,0xf8,0xe6,0x8f ,
0x82,0x86,0x91,0xd6,0x83,0x58,0xff,0x7a,0xac,0x1e,0x33,0xf4,0x4f,0x1b,0x99,0x0e ,
0x97,0xf2,0xb6,0xc9,0xe4,0xaf,0x86,0xef,0x4b,0xfd,0xf3,0xb1,0x5d,0xfc,0x8f,0xe5 ,
0xbd,0x7a,0xb2,0xa7,0x8e,0x62,0x86,0xfd,0x47,0x61,0xff,0xb0,0xf1,0x81,0x20,0x15 ,
0x09,0x3e,0x56,0xe4,0x18,0x53,0xa2,0x32,0xbf,0x27,0xfb,0x43,0x14,0x66,0x1f,0x4c ,
0x05,0x96,0x0a,0xdf,0x4c,0x1b,0x72,0xc8,0x84,0x8e,0xa4,0x68,0xc7,0xa1,0xc0,0x0b ,
0x1b,0x10,0x83,0x18,0xe6,0x90,0xa3,0xee,0x0e,0xe0,0x90,0xf9,0x47,0xfa,0x1f,0xde ,
0x91,0xf3,0x44,0xce,0x79,0xc2,0xb6,0x98,0xfd,0xb6,0x98,0xf1,0xa9,0x88,0x3b,0x22 ,
0xa7,0x45,0x7c,0x4b,0xa8,0x98,0x89,0x52,0xa1,0x58,0xa0,0xf0,0xa6,0x33,0x29,0xf1 ,
0xec,0xd9,0x54,0x2e,0x17,0x29,0xcd,0x71,0x2e,0xec,0x5b,0x46,0xa9,0xb6,0xf9,0x94 ,
0xea,0x62,0xdf,0xdc,0x31,0x20,0x74,0x51,0x1a,0xfd,0x8e,0xe9,0x56,0x68,0xcc,0x61 ,
0x81,0xff,0xe9,0xb6,0xe7,0x56,0x8a,0x5b,0x5b,0x97,0x5b,0xf4,0xf8,0xbb,0xab,0xff ,
0x19,0x75,0xc0,0x8c,0xe6,0xcb,0x2e,0x9b,0x87,0xf5,0xac,0xd7,0xdc,0x4d,0x1b,0xad ,
0xba,0xff,0xb9,0x17,0x51,0x26,0xc0,0x7e,0x15,0x1e,0xa4,0x74,0x2e,0x4f,0xf9,0x17 ,
0x57,0x50,0xf2,0xd9,0xb3,0x28,0x91,0xce,0xb2,0xcf,0x87,0xd9,0xff,0x96,0x50,0xd8 ,
0x61,0xa6,0x30,0xfb,0x66,0x36,0xb4,0x9c,0x72,0x83,0xfd,0x14,0xdb,0xf6,0xb1,0x90 ,
0x7f,0xc6,0xb3,0x98,0xf5,0xa6,0x21,0xf6,0x20,0x8e,0xf6,0xc8,0x1c,0x2b,0xe3,0x1f ,
0xe3,0x9d,0x59,0x19,0xff,0x75,0xdb,0xa0,0x19,0x63,0x1e,0x55,0x63,0xbd,0x17,0x53 ,
0x3e,0x8d,0x12,0x6e,0x45,0xe4,0xd4,0xe4,0x96,0x4e,0xca,0xf2,0x81,0xe2,0x38,0xb1 ,
0xfc,0xcb,0xe2,0x3d,0xdd,0x0f,0x1b,0x58,0x30,0xed,0x9b,0xce,0x43,0xa0,0x37,0x23 ,
0x6f,0xe8,0xb9,0x12,0x30,0x92,0x3e,0xa5,0x3c,0xe6,0x50,0xac,0x80,0x8d,0xfc,0x8e ,
0x5c,0x0b,0xde,0x81,0xdf,0xa8,0x47,0xf6,0xbc,0xcc,0xe0,0x5d,0xc6,0x86,0x31,0x87 ,
0xf9,0x71,0x7a,0x5a,0x15,0xfe,0x37,0xd6,0x61,0x16,0xb6,0x94,0xfb,0x2a,0x40,0xb1 ,
0xd1,0x9d,0x94,0x4b,0x0c,0x53,0xe9,0xeb,0x2e,0xc6,0x63,0xa1,0x51,0x5e,0xcb,0x78 ,
0x0d,0xdf,0x74,0x5a,0xd9,0xc6,0x78,0x9f,0x77,0x91,0xa0,0x69,0xc4,0x61,0x25,0xda ,
0x0c,0x1e,0xcc,0x8f,0xc9,0xdc,0xb3,0x7b,0xfe,0x93,0x75,0x9e,0xcc,0xff,0xab,0x56 ,
0x35,0x89,0x3d,0x6f,0xb7,0x9e,0xbe,0x17,0xfb,0xcd,0x4f,0xe3,0x21,0xd4,0x3b,0xe0 ,
0x67,0x31,0xfb,0xd6,0x02,0x4a,0x74,0xda,0x38,0xfe,0xb0,0x0f,0xf2,0xbb,0xc8,0x8d ,
0x9e,0x29,0x5f,0xe5,0x77,0xf8,0x8d,0x18,0x42,0xff,0xe3,0xdd,0x1a,0xbe,0xff,0xd4 ,
0x6f,0x6f,0xdc,0x53,0xda,0x1d,0x70,0x23,0xff,0xc1,0xe7,0x2b,0xfd,0xcf,0x58,0x9f ,
0x8f,0x3a,0x4c,0xce,0xfb,0x1e,0x3d,0xe2,0xd4,0x9c,0x5f,0x99,0x2c,0x05,0x2c,0x53 ,
0xf5,0x4f,0x8e,0x73,0x5a,0xc2,0xb5,0x98,0x79,0x13,0xb1,0x59,0xc4,0xa5,0x31,0xa7 ,
0xee,0x63,0x39,0xa3,0x36,0x1a,0x76,0x58,0x85,0xcd,0x15,0x03,0x96,0xf1,0x6f,0x1f ,
0x5f,0xda,0x54,0x59,0xff,0xf0,0xd8,0x4f,0xd7,0xff,0xb4,0xff,0x31,0x4d,0x53,0xf5 ,
0x1f,0xe4,0x00,0x5f,0xc0,0x13,0x7b,0x76,0xac,0xd7,0xee,0x46,0xfe,0x4e,0x7b,0x45 ,
0x3c,0x11,0x34,0xc4,0xf4,0xfa,0x0f,0x4f,0xcc,0x75,0x1f,0x9b,0x5e,0x13,0xfa,0xc0 ,
0x99,0xc1,0x76,0xeb,0xfd,0xba,0xdc,0x45,0x7d,0xb5,0xb7,0x91,0xf7,0xaa,0x76,0xf3 ,
0x3f,0xd3,0x94,0xff,0x4f,0xd3,0xb8,0x0f,0x64,0x24,0xe9,0x1e,0x74,0x58,0x5f,0xa4 ,
0x4d,0xf0,0x65,0xc1,0xab,0x9e,0x9b,0x7d,0x66,0xd8,0x19,0xf8,0x66,0x5a,0x44,0x8e ,
0xc3,0x9a,0xb0,0x3f,0xda,0xc4,0x74,0x39,0xb5,0x57,0x60,0x6f,0xb0,0x27,0xe0,0x81 ,
0x7d,0x31,0xdc,0x39,0x52,0xff,0xad,0xad,0xad,0x7b,0xed,0xee,0x7f,0xd8,0x03,0xfb ,
0x94,0x7b,0x40,0x07,0xde,0x87,0xfc,0x87,0xec,0x39,0x2a,0x6c,0x01,0xf1,0xdc,0x0c ,
0xfc,0xd0,0x07,0x78,0xe6,0xb9,0x9e,0xe3,0x22,0x3c,0xb0,0x36,0xd1,0xcd,0xba,0x70 ,
0x5a,0xb7,0xf5,0xd9,0xb5,0x79,0x06,0x3f,0x7b,0x63,0x18,0x7c,0xce,0x3a,0xff,0xfc ,
0xf3,0xe7,0xef,0x5e,0x7f,0x62,0xe0,0x9b,0xe1,0x1b,0x42,0x2e,0xc0,0x0f,0x99,0x48 ,
0x3d,0x7c,0xfd,0xb8,0xed,0x28,0xd4,0xd4,0x7a,0x6e,0xd0,0x65,0x9d,0x10,0x72,0x17 ,
0x35,0x82,0x90,0x45,0xa9,0x0b,0x72,0x51,0xb3,0x5f,0x3f,0x7e,0xc4,0x51,0x52,0x96 ,
0x12,0xa6,0x21,0xd7,0x1a,0xc0,0x84,0x6c,0x8d,0xb8,0x3b,0x6b,0xf7,0xfa,0xd3,0xb0 ,
0x81,0xfd,0x64,0xff,0x81,0xfd,0x52,0x0e,0x61,0xa7,0x72,0x49,0x29,0xd8,0x20,0x62 ,
0x4b,0x0e,0xf2,0x17,0x39,0x8e,0xf9,0x36,0xec,0xb0,0x1c,0xaa,0xa7,0x9d,0xeb,0xb5 ,
0xcb,0xa5,0xad,0x83,0x57,0xa9,0x43,0xbc,0xf3,0xb7,0xbf,0xf8,0x9f,0xec,0x89,0x8c ,
0x9a,0xb0,0x46,0x3e,0xb1,0x57,0xce,0xa5,0xcf,0xe8,0x34,0x68,0x5e,0xb6,0xad,0xca ,
0x3c,0xaf,0xeb,0xfc,0xa9,0x3a,0x96,0xbb,0xd9,0x8b,0x3d,0xfa,0xf9,0xa6,0xa9,0xf3 ,
0xbb,0xc3,0x36,0xec,0xbd,0x7a,0xba,0xfe,0x9c,0xa6,0x51,0xea,0x1f,0xfb,0xd0,0x2b ,
0x80,0x46,0xc1,0x0f,0xaf,0xd9,0x6c,0xf6,0x1a,0x22,0x53,0x15,0xeb,0x7d,0x20,0xdf ,
0x55,0x0f,0xd9,0x0b,0x9d,0x97,0x82,0x75,0xa8,0xd1,0xbe,0xe1,0xb5,0x99,0xb0,0x39 ,
0xc8,0x4f,0xe6,0x38,0xc8,0xf5,0xdc,0x73,0xcf,0x9d,0xfb,0x77,0xfe,0x27,0x6d,0x0f ,
0xfd,0x5f,0xa5,0x8e,0xe0,0x8b,0xb2,0x46,0xc6,0x77,0xcc,0x71,0x06,0x6b,0xc8,0xd1 ,
0x3f,0x3c,0x79,0xf8,0xd1,0x85,0x4e,0x4b,0x31,0xcd,0xb1,0x15,0x83,0xfb,0xc2,0xd2 ,
0x6f,0xed,0xda,0xd1,0xc0,0x6d,0xc8,0x6d,0xa6,0xf4,0x31,0x9c,0x93,0xb6,0x25,0xd7 ,
0xc0,0x3f,0x7a,0x3e,0xd8,0x5d,0x65,0xff,0x29,0xf5,0xcf,0x63,0x6f,0xc8,0x46,0xfa ,
0x26,0x7a,0x47,0xb9,0x76,0x13,0xaf,0xe1,0x9d,0xeb,0xa4,0xfb,0xe8,0x99,0x7a,0xa2 ,
0x67,0x0e,0x87,0x1c,0x1e,0xc0,0x37,0xec,0x83,0x2e,0x65,0x8f,0x89,0xb9,0xec,0x31 ,
0x2b,0xfb,0x4f,0xec,0x41,0xff,0xb9,0x7b,0x1f,0xce,0x63,0xaa,0x27,0x92,0xb1,0x11 ,
0x38,0xe5,0x5a,0xa5,0xae,0xfa,0xfd,0x2d,0xd5,0x69,0x9f,0xf2,0x51,0xd6,0x5b,0xfb ,
0xf1,0x77,0xbd,0x42,0x2e,0x33,0xe4,0x39,0xec,0xc5,0xb9,0x0a,0x19,0xcf,0x34,0x70 ,
0x54,0x49,0x9f,0x93,0x38,0x1b,0xf8,0xb9,0x90,0xc7,0x91,0xff,0xe1,0x9e,0x00,0x30 ,
0x71,0xb6,0x72,0x88,0xfe,0xdc,0xa9,0xcd,0x4b,0x77,0x59,0x2e,0x9a,0xe8,0xa9,0x0b ,
0x16,0xfc,0x96,0xaf,0xd2,0x3e,0xcb,0xef,0x69,0x9f,0xf9,0xf7,0x42,0x97,0x32,0x30 ,
0xd1,0x53,0x1f,0xe4,0x3e,0x7d,0x65,0x94,0xf7,0x18,0x70,0x04,0x0c,0xe8,0x01,0x4f ,
0xcc,0xa5,0x8c,0xa0,0x03,0xa3,0x1e,0xac,0x31,0x37,0xd9,0x85,0x7c,0x46,0xdb,0xd5 ,
0x13,0x8b,0x21,0xed,0xad,0xf1,0x6e,0x85,0x44,0xef,0xdf,0x0d,0x3f,0xd7,0x38,0xb6 ,
0x73,0x6e,0x0b,0x2e,0x22,0x0a,0x2d,0xa6,0x32,0xf7,0x89,0xe3,0x1b,0xb4,0xb7,0x86 ,
0xda,0x2c,0x27,0x8b,0x36,0xaa,0xc5,0x5f,0x2d,0xe3,0x88,0x11,0x67,0x05,0xcf,0x98 ,
0x4b,0xdb,0x12,0x71,0xad,0xbd,0xe1,0xc2,0x52,0x48,0x1d,0xa5,0x4d,0x56,0xd6,0xa1 ,
0xca,0x43,0xc4,0x32,0xe1,0x4f,0x89,0x8e,0x85,0x14,0xf6,0x1c,0x4e,0xa9,0x50,0x23 ,
0xd7,0x0e,0x87,0xf1,0x9d,0x83,0x99,0x0a,0xdd,0x4a,0x78,0xd8,0xa5,0xad,0xc4,0x59 ,
0xdc,0x13,0x20,0x36,0xc0,0xb6,0x24,0x4f,0xba,0x9f,0xae,0x16,0xb0,0x77,0xac,0xab ,
0x3b,0xa9,0xbc,0x41,0xfd,0x03,0xbe,0x1a,0x73,0x70,0x5d,0xb0,0x6e,0x3f,0xf4,0xc4 ,
0xa2,0x77,0x8d,0xb7,0x1f,0x44,0x89,0xe7,0xcf,0xa3,0xdc,0xf0,0xf7,0x94,0xe3,0x7e ,
0x31,0xfd,0x85,0x17,0x3d,0x1a,0xf3,0xc2,0x7d,0x7b,0xa8,0x6e,0x78,0xa8,0xc3,0x72 ,
0x4a,0x45,0x9d,0x54,0x23,0x69,0xe7,0x21,0x64,0x12,0xe5,0xd8,0x9a,0xf4,0x5b,0xdf ,
0xa3,0xcd,0xdc,0x93,0xb4,0x1f,0xc2,0xb0,0x2e,0xa0,0xf4,0xfb,0xf7,0x73,0xcc,0xb7 ,
0x88,0x5a,0x25,0xee,0x3b,0x9c,0xeb,0xc0,0xef,0x29,0x3f,0xf6,0x03,0x25,0x07,0x36 ,
0x53,0xae,0x3c,0x4e,0xe9,0xf7,0xee,0xa6,0x48,0xeb,0x7e,0x04,0x5e,0x53,0x9d,0xda ,
0xfb,0xbf,0x3c,0xa1,0xec,0x23,0xed,0x5b,0xca,0xc7,0x64,0xdc,0xc7,0x44,0x3d,0xda ,
0x45,0xe5,0x6e,0x65,0x02,0x7d,0x6f,0x92,0x6b,0xfd,0xe4,0xbb,0x6b,0x44,0xef,0x99 ,
0xdf,0x1a,0xa4,0xf0,0xda,0xf9,0xdc,0xf7,0x72,0x3d,0x58,0x2c,0x51,0x7c,0xe0,0x69 ,
0x4a,0x3f,0x77,0x26,0x65,0xcb,0x5c,0x8b,0x7e,0xea,0x42,0x1d,0x28,0x62,0x63,0x39 ,
0xa4,0x4d,0x24,0xdc,0xda,0xc5,0xb2,0x9e,0x81,0x7c,0xa0,0x6f,0xdb,0xca,0xde,0x1a ,
0xc8,0xab,0xd0,0x55,0x17,0xe4,0x7a,0x54,0xe4,0x8f,0xa8,0xd3,0x2c,0x6a,0x8b,0x6c ,
0xbf,0x57,0xd4,0xaf,0xd9,0x2f,0xfd,0x14,0x7b,0x72,0x1f,0x4a,0x7c,0xfc,0x24,0x95 ,
0xc6,0x4b,0x94,0xe1,0xe6,0x32,0x17,0xdd,0x46,0xe9,0x67,0xce,0xe4,0x1a,0x8f,0xe5 ,
0xe6,0x41,0x6e,0x05,0x0f,0x75,0x1b,0x01,0xb3,0xb1,0xa5,0xbf,0x7a,0x8a,0x7e,0x53 ,
0xef,0xcc,0xa7,0xef,0x39,0x69,0x5f,0xee,0xbd,0x06,0x26,0x43,0x1a,0x6a,0x10,0x5d ,
0xde,0x8e,0x43,0x45,0x5f,0x90,0xd9,0xe2,0x41,0x7d,0x0a,0x79,0x0b,0x1d,0x24,0xdf ,
0xb8,0x99,0x32,0x7d,0x0e,0x4a,0x6c,0x3e,0x8d,0x62,0x1d,0x0b,0xa7,0x6a,0x99,0x89 ,
0x90,0x15,0xf9,0xf5,0x9b,0xde,0xd5,0x47,0x71,0xaf,0x26,0x68,0x9f,0xb2,0xf5,0x8f ,
0x1f,0x6a,0x5c,0x1c,0x77,0x29,0x83,0xc8,0x43,0x11,0xd4,0x3c,0x88,0xbf,0x5e,0x4d ,
0xd4,0xdb,0xc9,0xb6,0xfd,0x29,0xf9,0xb9,0x47,0xf4,0x65,0x99,0x7e,0x1f,0x45,0x1e ,
0x9b,0x4d,0x89,0xb5,0xb3,0x29,0xd6,0xbe,0x50,0xc0,0x65,0xba,0x44,0xce,0x28,0x06 ,
0x54,0xf0,0x31,0xfc,0x99,0xfd,0x48,0xe1,0x70,0xc6,0xfd,0x8b,0x88,0x9d,0xdb,0x9f ,
0xb4,0x2d,0x8c,0xbb,0x6b,0x77,0xe4,0x02,0x56,0xd4,0xce,0xc0,0x21,0x78,0x48,0x3a ,
0x0e,0xe2,0x5a,0x7f,0x0e,0x25,0x9f,0x98,0x45,0xa9,0xbe,0x76,0x5d,0x1f,0x03,0xac ,
0x8f,0x75,0x07,0x32,0x7f,0x87,0xe0,0xde,0x49,0xef,0xb7,0xbd,0xa8,0x7b,0x04,0xef ,
0x83,0xdb,0x3d,0x66,0xd1,0xeb,0x21,0xd6,0x4b,0xfa,0x37,0xaf,0x3e,0x6e,0x5e,0xd2 ,
0x67,0xf9,0x6a,0xa2,0x5b,0x45,0xbd,0x20,0x68,0x8a,0x33,0x7d,0xd1,0xcd,0x67,0x50 ,
0xae,0x9f,0xe5,0xf2,0xc6,0x2d,0x2c,0xab,0x03,0x28,0xfb,0x79,0x87,0xd0,0x47,0x6e ,
0x20,0x04,0xfa,0x99,0xbf,0x43,0x88,0xe3,0x8d,0xf0,0x8f,0xf1,0x6e,0xc8,0x5f,0xf9 ,
0xda,0x7b,0xe3,0x49,0xfb,0x02,0xa6,0x8c,0x0b,0xcd,0xba,0xbd,0x56,0xe5,0xba,0x34 ,
0x37,0xeb,0x08,0xb9,0x49,0xc8,0x3d,0xf9,0xcc,0x99,0xac,0xc3,0x5f,0x28,0x5b,0x62 ,
0x9a,0xcb,0x25,0x4a,0x7d,0xd6,0x46,0xd1,0x27,0xe7,0xb1,0x3e,0x5c,0xba,0x3e,0xbe ,
0x0a,0xf2,0x5e,0xd1,0xb3,0x1b,0xb9,0x8c,0xef,0x9d,0x3a,0xad,0x7e,0x5d,0xbf,0xfe ,
0x6a,0x29,0x1f,0x99,0x3f,0xc7,0x5c,0x6a,0x73,0x21,0xa8,0x94,0x72,0x9d,0x0a,0xdb ,
0xf4,0xbe,0x94,0xee,0x73,0x51,0x9e,0xeb,0xf2,0xd8,0xe6,0xd3,0x29,0xbb,0x75,0x13 ,
0xfb,0x54,0x99,0x62,0xfe,0x65,0x94,0x68,0x9d,0x4b,0xa9,0x2d,0x42,0x1f,0xc2,0x3f ,
0xc2,0xbc,0x17,0x67,0x8a,0x41,0xa5,0xfc,0x87,0x53,0x5b,0x21,0xe3,0x74,0x65,0x7c ,
0x30,0x31,0x9e,0xf0,0xda,0x05,0x73,0xf3,0x01,0xf3,0xeb,0xb0,0xd1,0x04,0xec,0xff ,
0xad,0xdb,0x28,0x53,0x2c,0x53,0xfe,0xfb,0x67,0x29,0x35,0xf2,0x1d,0x65,0xb9,0xef ,
0x4f,0xf9,0x6d,0xa2,0xe7,0x48,0x79,0x6a,0x29,0xf9,0xce,0x1a,0x8a,0x3d,0x7b,0x2e ,
0xeb,0xe8,0x10,0x71,0x07,0x99,0xef,0x54,0xdf,0xda,0xe6,0xdc,0x8f,0xe3,0x1d,0xe8 ,
0x36,0x89,0x18,0x07,0xd8,0x88,0x17,0x88,0x1b,0x82,0x87,0x36,0xf3,0x99,0xc5,0x0d ,
0x4a,0x2a,0xeb,0xab,0x65,0xfb,0xe7,0x5e,0xfb,0x0b,0x27,0xa5,0x32,0x19,0x2a,0x8c ,
0x7e,0x4b,0xc9,0xde,0xf3,0x28,0xd2,0xb6,0x50,0xe8,0x34,0x02,0xff,0x60,0x1a,0x12 ,
0x8e,0x83,0x29,0xe3,0xaf,0xa7,0x52,0x8f,0x9a,0xe2,0xbb,0xb8,0x66,0x99,0x4f,0x2b ,
0xe3,0x1b,0xf4,0x8c,0xb9,0xac,0x5d,0x62,0x6e,0xab,0x93,0xeb,0x02,0xdc,0x43,0x09 ,
0xfb,0x4c,0x05,0x8f,0x62,0x5b,0x6d,0xa0,0x78,0xc7,0x41,0xf2,0x4e,0x01,0x4f,0xc8 ,
0x5c,0x3c,0x59,0x67,0xe8,0x9d,0x5d,0x12,0x36,0x62,0x25,0x60,0x55,0xc4,0x9f,0x59 ,
0x3c,0xf6,0xd0,0xf5,0x60,0xaf,0xea,0x7b,0x74,0xe9,0x41,0x5c,0x93,0xf5,0xf1,0x39 ,
0xe1,0xc7,0x09,0xf4,0x3f,0x8e,0x45,0x80,0xc5,0x43,0xaf,0xc9,0x12,0x6e,0x1d,0xcf ,
0x64,0x8f,0x95,0xf3,0xb4,0xba,0x65,0x8b,0xdd,0x26,0x6c,0x12,0x31,0x58,0xd2,0xca ,
0xb8,0xa6,0x62,0xb3,0xac,0x01,0x4e,0x3f,0x5d,0xaf,0x87,0x77,0xb6,0xd5,0x1d,0x9b ,
0x0f,0xa9,0x83,0x93,0x1b,0xd8,0xbe,0x9d,0xaa,0xa8,0xf9,0xe3,0x02,0xa6,0x78,0x17 ,
0xdf,0xc6,0x43,0x2a,0xeb,0x54,0x1b,0x1e,0x5d,0xdf,0x70,0x82,0xa8,0xb7,0x99,0x3e ,
0xe4,0x7b,0x03,0xee,0x9e,0x9c,0x6f,0xa5,0xfd,0xcf,0x30,0x6a,0x89,0x3d,0x78,0xcc ,
0x92,0x35,0xf7,0x90,0x47,0xbb,0xac,0x10,0x54,0xcb,0x5c,0x3f,0xc2,0x87,0x04,0xfc ,
0x94,0x47,0xd8,0xba,0xf0,0x55,0xce,0x11,0xe5,0xe1,0x76,0xeb,0x2a,0xec,0x3d,0xdd ,
0xa8,0x49,0x21,0x0b,0xbd,0xae,0x9d,0xd6,0xaf,0xac,0xd9,0x64,0xfd,0x06,0xde,0x1a ,
0x0d,0x5d,0xb0,0x3c,0xd6,0x52,0x8f,0xe8,0x23,0x24,0xfd,0xe2,0x9d,0xbf,0xf1,0x5c ,
0x5b,0x87,0x3d,0x36,0x3e,0x07,0xfb,0x40,0xdc,0x97,0xe7,0x8d,0x9e,0x41,0xe4,0x18 ,
0x7c,0xaf,0x84,0x8f,0xa7,0xd4,0xc5,0x77,0x76,0xdb,0xde,0xdc,0x6b,0xbe,0x21,0xfc ,
0xce,0x85,0xfe,0x4b,0xf7,0xa3,0x6c,0x97,0xf6,0xe6,0x4f,0x6b,0xeb,0xc5,0x9d,0xcb ,
0xf1,0xc7,0x1f,0x2f,0xe4,0x0d,0xd9,0x43,0x06,0xb2,0x16,0xac,0xb4,0x7f,0xc8,0x0d ,
0x6b,0x92,0x3f,0xe1,0x77,0x4d,0x7a,0x4f,0xc8,0xf2,0xae,0xcf,0xf8,0xad,0xbf,0x97 ,
0x83,0x1a,0xc7,0x48,0xa6,0xdf,0xaf,0x0e,0x46,0x3c,0xb5,0x87,0x63,0x0d,0xf7,0x77 ,
0xd2,0xc6,0x01,0x57,0xde,0xa3,0x57,0xe6,0x79,0xce,0xef,0xbb,0xd4,0x78,0x7c,0x4c ,
0xe8,0x1c,0x34,0xc8,0xbe,0x37,0xe1,0xa8,0xbd,0x6e,0x62,0x63,0xdd,0x24,0x6d,0xae ,
0x63,0x5b,0x34,0x5f,0x2f,0xfb,0xa7,0x96,0x96,0xc6,0x6a,0xd9,0xa3,0x49,0xf9,0xe0 ,
0xbd,0xb2,0x8e,0x33,0x6a,0x25,0x31,0x2a,0xef,0xd6,0x2a,0x6b,0x95,0xef,0xec,0xa6 ,
0x1a,0xb6,0xa7,0x67,0x32,0x5d,0xea,0xf3,0xdb,0x56,0x6b,0xb3,0x2b,0xef,0xe1,0x2a ,
0x69,0x05,0xac,0xca,0x73,0x0d,0x3c,0xe6,0xf3,0x30,0xff,0x4b,0x9d,0x24,0xcf,0x49 ,
0x1f,0xec,0xbd,0xfd,0xf8,0x39,0x85,0x2e,0xf5,0xce,0x5c,0x40,0xe9,0xe3,0xfb,0x94 ,
0x31,0xce,0x2b,0x63,0x79,0xef,0xa2,0xbe,0x5c,0xa7,0xe5,0xae,0xd7,0x8c,0xbe,0x58 ,
0xfa,0x98,0x1c,0x42,0x1e,0xfc,0xfb,0xf1,0xf1,0x06,0x33,0xff,0xd7,0x32,0x80,0x7b ,
0xfc,0x09,0xce,0x67,0xfc,0x4e,0x59,0xcf,0xa1,0x34,0xb1,0xe9,0x68,0xb6,0x1b,0x71 ,
0xbf,0xbe,0xf5,0xdb,0x27,0x97,0xaa,0xb2,0x56,0xa8,0xb8,0xcb,0x9f,0xf9,0x76,0xeb ,
0xf2,0xbd,0xe2,0x2e,0xf5,0x5b,0x7a,0xaa,0x1e,0xf7,0x64,0x88,0xe1,0x22,0x4f,0xa4 ,
0xb7,0x78,0xf9,0xae,0xfe,0x37,0x4a,0x73,0x9e,0xa2,0x6e,0x71,0x5f,0xf8,0xfd,0x2b ,
0x6b,0x4e,0x9c,0x0b,0x7f,0x90,0x67,0x45,0xdd,0xe5,0xb2,0xae,0x01,0xde,0xb8,0xb7 ,
0x9e,0x32,0x3b,0x07,0x28,0xf9,0xea,0xb5,0xec,0xdb,0x87,0x52,0x2e,0x15,0xa5,0xf4 ,
0xa7,0xad,0x94,0x4d,0x86,0xf9,0x1e,0xfa,0x48,0x8e,0x19,0xc8,0x51,0xda,0xdd,0x22 ,
0x66,0x4c,0xc7,0x89,0x2a,0xb6,0xef,0x7e,0xd0,0x1c,0xeb,0x38,0x98,0x52,0xaf,0x5d ,
0x4b,0xd9,0x5c,0x8e,0x92,0x2f,0x5d,0x4a,0xa9,0x0f,0xed,0x8c,0x7f,0x3b,0xe3,0x77 ,
0x01,0x9e,0xb0,0xa3,0x88,0xc7,0xf2,0x95,0x6e,0x17,0xba,0xac,0xdf,0x7b,0xec,0xd8 ,
0xfd,0x39,0x26,0x45,0xf9,0xbf,0x1c,0x3d,0x27,0xb7,0xce,0xe3,0xb3,0x97,0x18,0x30 ,
0x2e,0x03,0x1f,0x22,0xa7,0x27,0xdc,0xe2,0x7f,0x01,0xdc,0xad,0xc7,0xdf,0xb6,0x2f ,
0x3f,0x10,0x67,0xe5,0xf9,0xa8,0xdb,0x12,0xc9,0xf9,0x91,0xcf,0x2d,0x62,0x6f,0xdc ,
0x79,0x18,0x25,0x5f,0x5c,0x49,0x39,0xc0,0x78,0xf9,0x4a,0x86,0x39,0x57,0xe4,0x55 ,
0xde,0x83,0xf3,0xd1,0x0f,0xec,0x8d,0x0b,0x64,0xdc,0x83,0x2d,0xf2,0xb7,0xcf,0x39 ,
0xae,0xe0,0x2c,0xd3,0xea,0xa5,0x5c,0xfc,0x37,0xa6,0xfd,0x91,0x69,0x18,0xaf,0xdf ,
0x40,0x71,0xe6,0x0d,0xf7,0x23,0xcc,0xeb,0x17,0x3a,0xfd,0xd3,0xf6,0xc2,0x77,0x31 ,
0xb7,0x50,0x0f,0xe3,0x0e,0x1c,0xc1,0xb2,0x8a,0x40,0x66,0x90,0x1d,0xd3,0xb1,0x88 ,
0xf1,0x5f,0x45,0x19,0xfe,0x2f,0x21,0xc6,0xb2,0xc5,0x5d,0xe3,0x88,0xcb,0x7a,0xab ,
0xb4,0x43,0x23,0xc6,0x56,0x7d,0xb2,0xf6,0xc4,0xb9,0xcc,0xdf,0xf6,0xb2,0xff,0x30 ,
0xce,0x97,0x4e,0x43,0x66,0x6e,0xd0,0xa3,0xeb,0xd2,0x5b,0xc7,0x75,0x96,0x95,0xe1 ,
0x29,0xbf,0x7d,0x62,0xf8,0x37,0xce,0x56,0xda,0xcf,0x4e,0x47,0xdd,0x59,0x93,0xcc ,
0x43,0xca,0x75,0x28,0xfe,0x33,0xc0,0x59,0xe4,0x59,0x23,0xbe,0x99,0x69,0x92,0x7b ,
0xf5,0xc1,0x0e,0xeb,0x39,0xb2,0x5f,0xad,0xfc,0x2f,0x48,0xd6,0xc8,0xc3,0x0e,0x8e ,
0x5b,0x4f,0x69,0xf8,0xaf,0x47,0x9e,0xc5,0x40,0x1d,0x89,0xfb,0xfc,0xf5,0xd8,0x23 ,
0xfb,0x4a,0xa3,0xa7,0xac,0x92,0x73,0xf8,0xad,0x5e,0x4f,0xaa,0xef,0x8a,0xdc,0x22 ,
0x7b,0xd5,0x1e,0xf1,0xfe,0x3e,0x5c,0x09,0x7b,0xb0,0xd7,0x88,0x47,0xbb,0xe0,0x97 ,
0xbd,0xff,0xd6,0x56,0xf5,0x40,0xce,0x29,0x83,0xa2,0xee,0xe7,0xc1,0xb5,0xfa,0xd0 ,
0xcf,0xfc,0x4d,0xf6,0xa9,0x95,0xf8,0x25,0xff,0xbb,0xc3,0xd8,0xd1,0x61,0x3d,0x6d ,
0xb2,0xdb,0x2a,0xfe,0x3b,0xfc,0xbd,0x4d,0x3b,0xbd,0xf2,0xac,0x7c,0xca,0x18,0x58 ,
0x19,0x37,0x24,0x4f,0x46,0x0c,0x0f,0xf0,0xbd,0x72,0x50,0xfa,0xb9,0x8c,0xcb,0xbb ,
0xc4,0x98,0xff,0x7f,0xff,0xff,0xfe,0xff,0x19,0xbf,0x3f,0x01,0x4e,0xad,0xaf,0x97 ,
0xbc,0x20,0x00,0x00 
};



char about[] =
{
    VERSION_MAJOR_INIT,
    '.',
    VERSION_MINOR_INIT,
    '-', 'V', '-',
    BUILD_YEAR_CH0, BUILD_YEAR_CH1, BUILD_YEAR_CH2, BUILD_YEAR_CH3,
    '-',
    BUILD_MONTH_CH0, BUILD_MONTH_CH1,
    '-',
    BUILD_DAY_CH0, BUILD_DAY_CH1,
    'T',
    BUILD_HOUR_CH0, BUILD_HOUR_CH1,
    ':',
    BUILD_MIN_CH0, BUILD_MIN_CH1,
    ':',
    BUILD_SEC_CH0, BUILD_SEC_CH1,
    '\0'
};


AsyncWebServer server(80);

// Generally, you should use "unsigned long" for variables that hold time
// The value will quickly become too large for an int to store
unsigned long previousMillis = 0;    // will store last time DHT was updated

// Updates DHT readings every 10 seconds
const long interval = 10000;  
static int restartNow = false;
String content;

String networks;

const char upload_page[] PROGMEM = R"rawliteral(
<!DOCTYPE HTML>
<HTML>
  <HEAD>
    <TITLE>Firmware upload example</TITLE>
  </HEAD>
  <BODY>
    <H1>Choose network</H1>
      %IPSTR%
      <p>
      %NETWOKS%
      </p>
    <form id="settingsform" method="get" action="/setting">
      <label>SSID: </label>
      <input name="ssid" length=32>
      <input name="pass" length=64>
            <input type="submit"></form>
    <H1>Choose .ino.bin file</H1>
    <form id="uploadform" enctype="multipart/form-data" method="post" action="/upload">
       <input id="fileupload" name="inobinfile" type="file" />
       <input type="submit" value="submit" id="submit" />
    </form>
    <p>
    %ABOUT%
    </p>
  </BODY>
</HTML>)rawliteral";


// Replaces placeholder with DHT values
String upload_page_processor(const String& var)
{
  if(var == "IPSTR")
  {
    IPAddress ip = WiFi.softAPIP();
    String ipStr = String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]);
    return String(ipStr);
  }
  else if(var == "NETWOKS"){
    return networks;
  }
  else if(var == "ABOUT")
  {
    return String(about);
  }
  return String();
}


void indexrequest(AsyncWebServerRequest *request){
  request->send_P(200, "text/html", upload_page, upload_page_processor);
}





static void handle_update_progress_cb(AsyncWebServerRequest *request, String filename, size_t index, uint8_t *data, size_t len, bool final) {
  uint32_t free_space = (ESP.getFreeSketchSpace() - 0x1000) & 0xFFFFF000;
  if (!index){
    Serial.println("Update");
    Update.runAsync(true);
    if (!Update.begin(free_space)) {
      Update.printError(Serial);
    }
  }

  if (Update.write(data, len) != len) {
    Update.printError(Serial);
  }

  if (final) {
    if (!Update.end(true)){
      Update.printError(Serial);
    } else {
      restartNow = true;//Set flag so main loop can issue restart call
      Serial.println("Update complete");
    }
  }
}


static void handle_settings_progress_cb(AsyncWebServerRequest *request) 
{
     String qsid = request->arg("ssid");
      String qpass = request->arg("pass");
      if (qsid.length() > 0 && qpass.length() > 0) 
      {
        Serial.println("clearing eeprom");
        for (int i = 0; i < 96; ++i) {
          EEPROM.write(i, 0);
        }
        Serial.println(qsid);
        Serial.println("");
        Serial.println(qpass);
        Serial.println("");

        Serial.println("writing eeprom ssid:");
        for (int i = 0; i < qsid.length(); ++i)
        {
          EEPROM.write(i, qsid[i]);
          Serial.print("Wrote: ");
          Serial.println(qsid[i]);
        }
        Serial.println("writing eeprom pass:");
        for (int i = 0; i < qpass.length(); ++i)
        {
          EEPROM.write(32 + i, qpass[i]);
          Serial.print("Wrote: ");
          Serial.println(qpass[i]);
        }
        EEPROM.commit();

        content = "{\"Success\":\"saved to eeprom... reset to boot into new wifi\"}";
        ESP.reset();
        request->send(200, "application/json", content);
    }
    else
    {
        content = "{\"Error\":\"404 not found\"}";
        Serial.println("Sending 404");
        request->send(404, "application/json", content);
    }
}




const char index_html[] PROGMEM = R"rawliteral(
<!DOCTYPE HTML><html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
  <style>
    html {
     font-family: Arial;
     display: inline-block;
     margin: 0px auto;
     text-align: center;
    }
    h2 { font-size: 3.0rem; }
    p { font-size: 3.0rem; }
    .units { font-size: 1.2rem; }
    .dht-labels{
      font-size: 1.5rem;
      vertical-align:middle;
      padding-bottom: 15px;
    }
  </style>
</head>
<body>
  <p>
    <i class="fas fa-thermometer-half" style="color:#059e8a;"></i> 
    <span class="dht-labels">Temperature</span> 
    <span id="temperature">%TEMPERATURE%</span>
    <sup class="units">&deg;C</sup>
  </p>
  <p>
    <i class="fas fa-tint" style="color:#00add6;"></i> 
    <span class="dht-labels">Humidity</span>
    <span id="humidity">%HUMIDITY%</span>
    <sup class="units">%</sup>
  </p>
</body>
<script>
setInterval(function ( ) {
  var xhttp = new XMLHttpRequest();
  xhttp.onreadystatechange = function() {
    if (this.readyState == 4 && this.status == 200) {
      document.getElementById("temperature").innerHTML = this.responseText;
    }
  };
  xhttp.open("GET", "/temperature", true);
  xhttp.send();
}, 10000 ) ;

setInterval(function ( ) {
  var xhttp = new XMLHttpRequest();
  xhttp.onreadystatechange = function() {
    if (this.readyState == 4 && this.status == 200) {
      document.getElementById("humidity").innerHTML = this.responseText;
    }
  };
  xhttp.open("GET", "/humidity", true);
  xhttp.send();
}, 10000 ) ;
</script>
</html>)rawliteral";

// Replaces placeholder with DHT values
String processor(const String& var){
  //Serial.println(var);
  if(var == "TEMPERATURE"){
    return String(t);
  }
  else if(var == "HUMIDITY"){
    return String(h);
  }
  return String();
}

void setup()
{
  // Serial port for debugging purposes
  Serial.begin(115200);
  Serial.println("Connecting to ESP..");

  //dht.begin();

  WiFi.disconnect();
  WiFi.softAPdisconnect();
  WiFi.mode(WIFI_OFF);
  delay(500);

  EEPROM.begin(512); //Initializing EEPROM
 
  
  WiFi.mode(WIFI_STA);

  #ifdef HOME
  WiFi.config(IPAddress(192,168,0,LOCAL_IP_ADDRESS),IPAddress(192,168,0,1),
              IPAddress(255,255,255,0),IPAddress(192,168,0,1));
  #else
  WiFi.config(IPAddress(10,10,10,141),IPAddress(10,10,10,1),
              IPAddress(255,255,255,0),IPAddress(10,10,10,1));
  #endif

// Connect to Wi-Fi
  WiFi.begin(ssid, password);
  unsigned int attempt = 0;

   while (WiFi.status() != WL_CONNECTED) 
    {
        delay(1000);
        Serial.println("1 Connecting to WiFi..");
        attempt++;
        if (attempt == 20)
        {
          break;
        }
    }

    if (attempt == 20) 
    {
        Serial.println("No WiFi default Network found. Try to use saved network data....");
        attempt = 0;
        // Read eeprom for ssid and password
        Serial.println("Reading EEPROM ssid");

        String esid;
        for (int i = 0; i < 32; ++i)
        {
            esid += char(EEPROM.read(i));
        }
        Serial.println();
        Serial.print("SSID: ");
        Serial.println(esid);
        Serial.println("Reading EEPROM pass");

        String epass = "";
        for (int i = 32; i < 96; ++i)
        {
            epass += char(EEPROM.read(i));
        }
        Serial.print("PASS: ");
        Serial.println(epass);

        WiFi.begin(esid.c_str(), epass.c_str());        

        while (WiFi.status() != WL_CONNECTED) 
        {
            delay(1000);
            Serial.println("2 Connecting to WiFi..");
            attempt++;
            if (attempt == 20){
              break;
            }
        }
    }

    if (attempt == 20) 
    {
        WiFi.mode(WIFI_OFF);
        delay(500);
        
        int n = WiFi.scanNetworks();
        Serial.println("scan completed");
        if (n == 0)
        {
                  Serial.println("No WiFi Networks found");
        }
        else
        { // https://www.circuitschools.com/change-wifi-credentials-of-esp8266-without-uploading-code-again/
            Serial.print(n);
            Serial.println(" Networks found");
            networks = "<ol style=\"list-style-type:lower-alpha\">";

            for (int i = 0; i < n; ++i)
            {
                // Print SSID and RSSI for each network found
                Serial.print(i + 1);
                Serial.print(": ");
                Serial.print(WiFi.SSID(i));
                Serial.print(" (");
                Serial.print(WiFi.RSSI(i));
                Serial.print(")");
                Serial.println((WiFi.encryptionType(i) == ENC_TYPE_NONE) ? " " : "*");
                // Print SSID and RSSI for each network found
                networks += "<li>";
                networks += WiFi.SSID(i);
                networks += " (";
                networks += WiFi.RSSI(i);
                networks += ")";
                networks += (WiFi.encryptionType(i) == ENC_TYPE_NONE) ? " " : "*";
                networks += "</li>";
                delay(10);
            }
        }
        Serial.println("");

        networks += "</ol>";
        
        WiFi.mode(WIFI_AP);
        // Print ESP8266 Local IP Address
        
        char * bufIP = new char[40]();
        sprintf(bufIP, "%d.%d.%d.%d", local_IP[0], local_IP[1], local_IP[2], local_IP[3]);
        Serial.println(bufIP);
        Serial.println(WiFi.softAPConfig(local_IP, gateway, subnet) ? "Ready" : "Failed!"); 
        WiFi.softAP(ssid_soft, password_soft);
        
        server.on("/", HTTP_GET, indexrequest);

        server.on("/setting", HTTP_GET, handle_settings_progress_cb);
    } 
    else 
    {
         // Print ESP8266 Local IP Address
          Serial.println(WiFi.localIP());
          // Route for root / web page
          server.on("/", HTTP_GET, [](AsyncWebServerRequest *request){
            request->send_P(200, "text/html", index_html, processor);
          });
          server.on("/temperature", HTTP_GET, [](AsyncWebServerRequest *request){
            request->send_P(200, "text/plain", String(t).c_str());
          });
          server.on("/humidity", HTTP_GET, [](AsyncWebServerRequest *request){
            request->send_P(200, "text/plain", String(h).c_str());
          });
    } // if (attempt == 20)

    server.on("/all", HTTP_GET, [](AsyncWebServerRequest *request){
        request->send_P(200, "text/plain", String(String(t)+" "+String(h)).c_str());
    });

    server.on("/favicon.ico", HTTP_GET, [](AsyncWebServerRequest *request){
        AsyncWebServerResponse *response = request->beginResponse_P(200, "image/x-icon", favicon_ico_gz, favicon_ico_gz_len);
        response->addHeader("Content-Encoding", "gzip");
        request->send(response);
    });


    server.on("/about", HTTP_GET, [](AsyncWebServerRequest *request){
        request->send(200, "text/plain",String(about));
    });


    // handler for the /update form POST (once file upload finishes)
    server.on("/upload", HTTP_POST, [](AsyncWebServerRequest *request){
        request->send(200);
    }, handle_update_progress_cb);

    server.onNotFound([](AsyncWebServerRequest *request){
      request->send(404);
    });
    
    // Start server
    server.begin();
}// setup
 
void loop()
{  

  if (restartNow){
    Serial.println("Restart");
    ESP.restart();
  }

  
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= interval) {
    // save the last time you updated the DHT values
    previousMillis = currentMillis;
    // Read temperature as Celsius (the default)
    float newT = dht.readTemperature();
    // Read temperature as Fahrenheit (isFahrenheit = true)
    //float newT = dht.readTemperature(true);
    // if temperature read failed, don't change t value
    if (isnan(newT)) {
      //Serial.println("Failed to read from DHT sensor!");
    }
    else {
      t = newT;
      //Serial.println(t);
    }
    // Read Humidity
    float newH = dht.readHumidity();
    // if humidity read failed, don't change h value 
    if (isnan(newH)) {
      //Serial.println("Failed to read from DHT sensor!");
    }
    else {
      h = newH;
     // Serial.println(h);
    }
  }
}
